﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml.Linq;

namespace LOLAPP.Modele
{
    public class Manager : IPersistanceManager
    {
        public List<Champion> _champions { get; private set; }
        public List<Strategie> _strategies { get; private set; }
        public IPersistanceManager Persistance { get; }

        public Manager(IPersistanceManager Pers)
        {
            _champions = new List<Champion>();
            _strategies = new List<Strategie>();
            Persistance = Pers;
        }

        public void AddChampion(Champion champion)
        {
            _champions.Add(champion);
        }

        public void RemoveChampion(Champion champion)
        {
            _champions.Remove(champion);
        }

        public List<Champion> GetAllChampions()
        {
            return _champions;
        }



        public void AddAbility(Champion champion, string abilityName)
        {
            var ability = new Ability(abilityName);
            champion.Abilities.Add(ability);
        }

        public void RemoveAbility(Champion champion, string abilityName)
        {
            var ability = champion.Abilities.FirstOrDefault(a => a.Name == abilityName);
            if (ability != null)
            {
                champion.Abilities.Remove(ability);
            }
        }



        public void AddStrategie(Strategie strategie)
        {
            _strategies.Add(strategie);
        }

        public void RemoveStrategie(Strategie strategie)
        {
            _strategies.Remove(strategie);
        }

        public List<Strategie> GetAllStrategies()
        {
            return _strategies;
        }

        public (List<Strategie>, List<Champion>) Chargdon()
        {
            int donnees = Persistance.Chargdon();
            foreach (var i in donnees.List<Strategie>)
            {
                AddStrategie(i);
            }

            foreach (var j in donnees.List<Champion>)
            {
                AddChampion(j);
            }
        }
        public void Sauvdon(List<Strategie> s, List<Champion> c)
        {
            Persistance.Sauvdon(s, c);
        }
    }
}